! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!
! Ammendments
!
! AMK - 07/07/2000
! The column NOBS has now been renamed to SRC_ID
!
!
program checkoutput
use dal
use errorhandling

implicit none

type(DataSetT)  :: listDataSet
type(TableT)    :: tableDataSet
type(ColumnT)   :: listColumn
integer(kind=int32), pointer :: nobs(:)
integer i

listDataSet = dataSet("testlist.fts", read)
tableDataSet = table(listDataSet, "SRCLIST")
i = numberofRows(tableDataSet)
write(*,*) i
! Altered for new test data
!if (i /= 113) call fatal("failed","wrong number of combined sources")
if ( abs(i - 0) .gt. 3) call fatal("failed","wrong number of combined sources")
!
! AMK - Removed colur test below as currently not produced in data.
! Must look into this as required in specification 
!listColumn = column(tableDataSet, "COLOUR_U_B",read)
!call release(listColumn)
!listColumn = column(tableDataSet, "COLOUR_B_V",read)
!call release(listColumn)
!call release(listDataSet)
 
listDataSet = dataSet("testoswlist_u.fts", read)
tableDataSet = table(listDataSet, "SRCLIST")
!listColumn = column(tableDataSet, "NOBS",read)
listColumn = column(tableDataSet, "SRC_ID",read)
nobs => int32data(listColumn)
!if (nobs(95) /= 96) call fatal("failed","wrong source to obs correspondence")
!if (nobs(4) /= 5) call fatal("failed","wrong source to obs correspondence")
call release(listColumn)
call release(listDataSet)

listDataSet = dataSet("testoswlist_b.fts", read)
tableDataSet = table(listDataSet, "SRCLIST")
!listColumn = column(tableDataSet, "NOBS",read)
listColumn = column(tableDataSet, "SRC_ID",read)
nobs => int32data(listColumn)
!if (nobs(5) /= 11) call fatal("failed","wrong source to obs correspondence")
listDataSet = dataSet("testoswlist_b.fts", read)
tableDataSet = table(listDataSet, "SRCLIST")
listColumn = column(tableDataSet, "SRC_ID",read)
!listColumn = column(tableDataSet, "NOBS",read)
nobs => int32data(listColumn)
!if (nobs(31) /= 37) call fatal("failed","wrong source to obs correspondence")
listDataSet = dataSet("testoswlist_b.fts", read)
tableDataSet = table(listDataSet, "SRCLIST")
!listColumn = column(tableDataSet, "NOBS",read)
listColumn = column(tableDataSet, "SRC_ID",read)
nobs => int32data(listColumn)
!if (nobs(70) /= 76) call fatal("failed","wrong source to obs correspondence")
call release(tableDataSet)
call release(listDataSet)

! Data set below not in current data det.
!listDataSet = dataSet("testoswlist_v.fts", read)
!tableDataSet = table(listDataSet, "SRCLIST")
!listColumn = column(tableDataSet, "NOBS",read)
!nobs => int32data(listColumn)
!if (nobs(109) /= 113) call fatal("failed","wrong source to obs correspondence")
!call release(listColumn)
!call release(listDataSet)

end




